package me.unurled.sacredrealms.sr.components.cutscene.npc;

import static me.unurled.sacredrealms.sr.components.packet.PacketManager.sendPacketTo;

import com.github.retrooper.packetevents.wrapper.play.server.WrapperPlayServerEntityAnimation;
import com.github.retrooper.packetevents.wrapper.play.server.WrapperPlayServerEntityAnimation.EntityAnimationType;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.Contract;
import org.jetbrains.annotations.NotNull;

public enum ArmSwing {
  LEFT,
  RIGHT,
  BOTH;

  public static void swingArm(@NotNull ArmSwing arm, Player p, int entityId) {
    // Swing the arm
    if (arm.isLeft()) {
      sendPacketTo(
          new WrapperPlayServerEntityAnimation(entityId, EntityAnimationType.SWING_OFF_HAND), p);
    }
    if (arm.isRight()) {
      sendPacketTo(
          new WrapperPlayServerEntityAnimation(entityId, EntityAnimationType.SWING_MAIN_ARM), p);
    }
  }

  @Contract(pure = true)
  public @NotNull Boolean isLeft() {
    return this == LEFT || this == BOTH;
  }

  @Contract(pure = true)
  public @NotNull Boolean isRight() {
    return this == RIGHT || this == BOTH;
  }
}
