package me.unurled.sacredrealms.sr.components.difficulty;

import static me.unurled.sacredrealms.sr.utils.Component.textComp;

import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;

public enum Difficulty {
  EASY(textComp("Easy"), 1.75, 0.75, NamedTextColor.GREEN),
  NORMAL(textComp("Normal"), 1, 1, NamedTextColor.YELLOW),
  HARD(textComp("Hard"), 0.75, 1.75, NamedTextColor.RED),
  INSANE(textComp("<obf>aa</obf>Insane<obf>aa</obf>"), 0.05, 5, NamedTextColor.DARK_RED);

  private final TextComponent name;
  private final double damageMultiplier;
  private final double xpMultiplier;
  private final TextColor color;

  Difficulty(TextComponent name, double damageMultiplier, double xpMultiplier, TextColor color) {
    this.name = name;
    this.damageMultiplier = damageMultiplier;
    this.xpMultiplier = xpMultiplier;
    this.color = color;
  }

  public TextComponent getName() {
    return this.name;
  }

  public double getDamageMultiplier() {
    return this.damageMultiplier;
  }

  public double getXpMultiplier() {
    return this.xpMultiplier;
  }

  public TextColor getColor() {
    return this.color;
  }
}
