package me.unurled.sacredrealms.sr.gui.treasure;

import static me.unurled.sacredrealms.sr.utils.Items.cancelItem;

import me.unurled.sacredrealms.sr.components.treasure.Treasure;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.ItemProvider;
import xyz.xenondevs.invui.item.builder.ItemBuilder;
import xyz.xenondevs.invui.item.impl.AbstractItem;
import xyz.xenondevs.invui.window.Window;

public class CancelItem extends AbstractItem {

  public CancelItem() {}

  /**
   * Gets the {@link ItemProvider}. This method gets called every time a {@link Window} is notified
   * ({@link #notifyWindows()}).
   *
   * @return The {@link ItemProvider}
   */
  @Override
  public ItemProvider getItemProvider() {
    return new ItemBuilder(cancelItem());
  }

  /**
   * A method called if the {@link ItemStack} associated to this {@link Item} has been clicked by a
   * player.
   *
   * @param clickType The {@link ClickType} the {@link Player} performed.
   * @param player The {@link Player} who clicked on the {@link ItemStack}.
   * @param event The {@link InventoryClickEvent} associated with this click.
   */
  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull InventoryClickEvent event) {
    player.closeInventory();
  }
}
