package me.unurled.sacredrealms.sr.gui.treasure;

import static me.unurled.sacredrealms.sr.utils.Component.textComp;

import me.unurled.sacredrealms.sr.components.treasure.Treasure;
import me.unurled.sacredrealms.sr.components.treasure.TreasureManager;
import me.unurled.srcore.api.Manager;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.ItemProvider;
import xyz.xenondevs.invui.item.builder.ItemBuilder;
import xyz.xenondevs.invui.item.impl.AbstractItem;
import xyz.xenondevs.invui.window.Window;

public class DeleteItem extends AbstractItem {

  private final Treasure treasure;

  public DeleteItem(Treasure treasure) {
    this.treasure = treasure;
  }

  /**
   * Gets the {@link ItemProvider}. This method gets called every time a {@link Window} is notified
   * ({@link #notifyWindows()}).
   *
   * @return The {@link ItemProvider}
   */
  @Override
  public ItemProvider getItemProvider() {
    ItemStack delete = new ItemStack(Material.RED_STAINED_GLASS_PANE);
    ItemMeta deleteMeta = delete.getItemMeta();
    deleteMeta.displayName(textComp("<b><red>Delete</red></b>"));
    delete.setItemMeta(deleteMeta);
    return new ItemBuilder(delete);
  }

  /**
   * A method called if the {@link ItemStack} associated to this {@link Item} has been clicked by a
   * player.
   *
   * @param clickType The {@link ClickType} the {@link Player} performed.
   * @param player The {@link Player} who clicked on the {@link ItemStack}.
   * @param event The {@link InventoryClickEvent} associated with this click.
   */
  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull InventoryClickEvent event) {
    // delete treasure
    if (!player.hasPermission("sr.treasure.delete")) {
      return;
    }
    TreasureManager treasureManager = Manager.getInstance(TreasureManager.class);
    treasureManager.removeTreasure(treasure);
    player.sendMessage(textComp("<red>Treasure deleted!"));
    player.closeInventory();
  }
}
