package me.unurled.sacredrealms.sr.gui.treasure;

import static me.unurled.sacredrealms.sr.utils.Items.glassPane;

import java.util.Map;
import me.unurled.sacredrealms.sr.components.treasure.Treasure;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.gui.Gui;
import xyz.xenondevs.invui.inventory.Inventory;
import xyz.xenondevs.invui.inventory.VirtualInventory;
import xyz.xenondevs.invui.inventory.event.UpdateReason;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.impl.SimpleItem;

public class TreasureGUI {

  private TreasureGUI() {}

  @NotNull
  public static Gui createGui(@NotNull Treasure treasure) {
    ItemStack itemStack = glassPane();
    Item pane = new SimpleItem(itemStack);

    Inventory inventory = new VirtualInventory(27);
    inventory.setPreUpdateHandler(
        (itemPreUpdateEvent) -> {
          if (itemPreUpdateEvent.isAdd()
              || itemPreUpdateEvent.isRemove()
              || itemPreUpdateEvent.isSwap()) {
            itemPreUpdateEvent.setCancelled(false);
          }
        });

    Map<Integer, ItemStack> items = treasure.getItems();
    if (!items.isEmpty()) {
      for (int i = 0; i < items.size(); i++) {
        inventory.setItem(UpdateReason.SUPPRESSED, i, items.get(i));
      }
    }

    Gui gui = Gui.empty(9, 5);
    gui.fill(pane, true);
    gui.fillRectangle(0, 1, 9, inventory, true);
    gui.setItem(39, new DeleteItem(treasure));
    gui.setItem(40, new CancelItem());
    gui.setItem(41, new ConfirmItem(treasure));

    return gui;
  }
}
